Loading...
Searching...
No Matches
Catch::Clara::Detail::ParserRefImpl< DerivedT > Class Template Reference

`#include <catch_amalgamated.hpp>`

Inheritance diagram for Catch::Clara::Detail::ParserRefImpl< DerivedT >:
[legend]
Collaboration diagram for Catch::Clara::Detail::ParserRefImpl< DerivedT >:
[legend]

## Public Member Functions

template<typename LambdaT>
| ParserRefImpl (accept_many_t, LambdaT const &ref, StringRef hint)
template<typename T, typename = typename std::enable_if_t< !Detail::is_unary_function<T>::value>>
| ParserRefImpl (T &ref, StringRef hint)
template<typename LambdaT, typename = typename std::enable_if_t< Detail::is_unary_function<LambdaT>::value>>
| ParserRefImpl (LambdaT const &ref, StringRef hint)
DerivedT & | operator() (StringRef description) &
DerivedT && | operator() (StringRef description) &&
auto | optional () -> DerivedT &
auto | required () -> DerivedT &
auto | isOptional () const -> bool
auto | cardinality () const -> size_t override
StringRef | hint () const
Public Member Functions inherited from Catch::Clara::Detail::ComposableParserImpl< DerivedT >
template<typename T>
auto | operator| (T const &other) const -> Parser
template<typename T>
Parser | operator| (T const &other) const
Public Member Functions inherited from Catch::Clara::Detail::ParserBase
virtual | ~ParserBase ()=default
virtual auto | validate () const -> Result
virtual auto | parse (std::string const &exeName, TokenStream tokens) const -> InternalParseResult=0
InternalParseResult | parse (Args const &args) const

## Protected Member Functions

| ParserRefImpl (std::shared_ptr< BoundRef > const &ref)

## Protected Attributes

Optionality | m_optionality = Optionality::Optional
std::shared_ptr< BoundRef > | m_ref
StringRef | m_hint
StringRef | m_description

## Constructor & Destructor Documentation

## ParserRefImpl() [1/4]

template<typename DerivedT>

Catch::Clara::Detail::ParserRefImpl< DerivedT >::ParserRefImpl | ( | std::shared_ptr< BoundRef > const & | ref | ) |

inlineexplicitprotected

## ParserRefImpl() [2/4]

template<typename DerivedT>
template<typename LambdaT>

Catch::Clara::Detail::ParserRefImpl< DerivedT >::ParserRefImpl | ( | accept_many_t | ,
|  | LambdaT const & | ref,
|  | StringRef | hint )

inline

Here is the call graph for this function:

## ParserRefImpl() [3/4]

template<typename DerivedT>
template<typename T, typename = typename std::enable_if_t< !Detail::is_unary_function<T>::value>>

Catch::Clara::Detail::ParserRefImpl< DerivedT >::ParserRefImpl | ( | T & | ref,
|  | StringRef | hint )

inline

Here is the call graph for this function:

## ParserRefImpl() [4/4]

template<typename DerivedT>
template<typename LambdaT, typename = typename std::enable_if_t< Detail::is_unary_function<LambdaT>::value>>

Catch::Clara::Detail::ParserRefImpl< DerivedT >::ParserRefImpl | ( | LambdaT const & | ref,
|  | StringRef | hint )

inline

Here is the call graph for this function:

## Member Function Documentation

## cardinality()

template<typename DerivedT>

auto Catch::Clara::Detail::ParserRefImpl< DerivedT >::cardinality | ( |  | ) | const -> size_t

inlineoverridevirtual

Reimplemented from Catch::Clara::Detail::ParserBase.

## hint()

template<typename DerivedT>

StringRef Catch::Clara::Detail::ParserRefImpl< DerivedT >::hint | ( |  | ) | const

inline

Here is the caller graph for this function:

## isOptional()

template<typename DerivedT>

auto Catch::Clara::Detail::ParserRefImpl< DerivedT >::isOptional | ( |  | ) | const -> bool

inline

## operator()() [1/2]

template<typename DerivedT>

DerivedT & Catch::Clara::Detail::ParserRefImpl< DerivedT >::operator() | ( | StringRef | description | ) | &

inline

## operator()() [2/2]

template<typename DerivedT>

DerivedT && Catch::Clara::Detail::ParserRefImpl< DerivedT >::operator() | ( | StringRef | description | ) | &&

inline

## optional()

template<typename DerivedT>

auto Catch::Clara::Detail::ParserRefImpl< DerivedT >::optional | ( |  | ) | -> DerivedT&

inline

## required()

template<typename DerivedT>

auto Catch::Clara::Detail::ParserRefImpl< DerivedT >::required | ( |  | ) | -> DerivedT&

inline

## Member Data Documentation

## m_description

template<typename DerivedT>

StringRef Catch::Clara::Detail::ParserRefImpl< DerivedT >::m_description

protected

## m_hint

template<typename DerivedT>

StringRef Catch::Clara::Detail::ParserRefImpl< DerivedT >::m_hint

protected

## m_optionality

template<typename DerivedT>

Optionality Catch::Clara::Detail::ParserRefImpl< DerivedT >::m_optionality = Optionality::Optional

protected

## m_ref

template<typename DerivedT>

std::shared_ptr<BoundRef> Catch::Clara::Detail::ParserRefImpl< DerivedT >::m_ref

protected

The documentation for this class was generated from the following file:

- tests/vendor/catch_amalgamated.hpp